Index: trunk/services/admins.php
===================================================================
--- trunk/services/admins.php	(revision 143)
+++ trunk/services/admins.php	(revision 147)
@@ -202,5 +202,5 @@
     }
 
-    if (getFormData('user_type') == 'root' && 'root' != $auth->getVal('user_type')) {
+    if (getFormData('user_type') == 'root' && 'root' != $auth->get('user_type')) {
         $fv->addError('user_type', sprintf(_("You do not have clearance to create a user with root privileges."), null));
     }
@@ -343,5 +343,5 @@
     $qid = $db->query("SELECT COUNT(*) from admin_tbl");
     list($num_admins) = mysql_fetch_row($qid);
-    if ('root' == $user_type && 'root' != $auth->getVal('user_type')) {
+    if ('root' == $user_type && 'root' != $auth->get('user_type')) {
         // Only root users can delete root users!
         $app->raiseMsg(_("You do not have clearance to delete a root administrator."), MSG_NOTICE, __FILE__, __LINE__);
@@ -349,5 +349,5 @@
         // There must always be at least one admnistrator!
         $app->raiseMsg(_("You cannot delete the only administrator in the database. There must be at least one to log in and create other users."), MSG_NOTICE, __FILE__, __LINE__);
-    } else if ($auth->getVal('user_id') == $id) {
+    } else if ($auth->get('user_id') == $id) {
         // Do not delete yourself!
         $app->raiseMsg(_("You cannot delete yourself."), MSG_NOTICE, __FILE__, __LINE__);
@@ -388,5 +388,5 @@
             '" . $db->escapeString($frm['email']) . "',
             '" . $db->escapeString($frm['user_type']) . "',
-            '" . $db->escapeString($auth->getVal('user_id')) . "',
+            '" . $db->escapeString($auth->get('user_id')) . "',
             NOW()
         )
@@ -435,5 +435,5 @@
             email = '" . $db->escapeString($frm['email']) . "',
             user_type = '" . $db->escapeString($frm['user_type']) . "',
-            modified_by_user_id = '" . $db->escapeString($auth->getVal('user_id')) . "',
+            modified_by_user_id = '" . $db->escapeString($auth->get('user_id')) . "',
             modified_datetime = NOW()
         WHERE admin_id = '" . $db->escapeString($frm['admin_id']) . "'
Index: trunk/services/login.php
===================================================================
--- trunk/services/login.php	(revision 143)
+++ trunk/services/login.php	(revision 147)
@@ -21,8 +21,8 @@
         $app->raiseMsg(_("You are now logged in."), MSG_SUCCESS, __FILE__, __LINE__);
         $app->dieBoomerangURL('login');
-        $app->logMsg(sprintf('%s %s successfully logged-in.', $auth->getVal('auth_name'), $frm['username']), LOG_INFO, __FILE__, __LINE__);
+        $app->logMsg(sprintf('%s %s successfully logged-in.', $auth->get('auth_name'), $frm['username']), LOG_INFO, __FILE__, __LINE__);
     } else {
         $app->raiseMsg(_("Login failed, please try again."), MSG_NOTICE, __FILE__, __LINE__);
-        $app->logMsg(sprintf('%s %s failed login using (MD5ed) password: %s', ucfirst($auth->getVal('auth_name')), $frm['username'], md5($frm['password'])), LOG_NOTICE, __FILE__, __LINE__);
+        $app->logMsg(sprintf('%s %s failed login using (MD5ed) password: %s', ucfirst($auth->get('auth_name')), $frm['username'], md5($frm['password'])), LOG_NOTICE, __FILE__, __LINE__);
     }
 }
Index: trunk/services/logout.php
===================================================================
--- trunk/services/logout.php	(revision 143)
+++ trunk/services/logout.php	(revision 147)
@@ -9,5 +9,5 @@
     require_once 'codebase/lib/Lock.inc.php';
     $lock =& Lock::getInstance($auth);
-    $lock->removeAll($auth->getVal('user_id'));
+    $lock->removeAll($auth->get('user_id'));
 }
 
Index: trunk/services/password.php
===================================================================
--- trunk/services/password.php	(revision 143)
+++ trunk/services/password.php	(revision 147)
@@ -48,13 +48,13 @@
     }
 
-    if (!$fv->anyErrors() && false === $auth->authenticate($auth->getVal('username'), $frm['oldpassword'])) {
+    if (!$fv->anyErrors() && false === $auth->authenticate($auth->get('username'), $frm['oldpassword'])) {
         $fv->addError('oldpassword', _("Your <strong>Old password</strong> failed authentication."));
-        $app->logMsg(sprintf('Password change failed for %s, using (md5ed) password: %s', $auth->getVal('username'), md5($frm['oldpassword'])), LOG_NOTICE, __FILE__, __LINE__);
+        $app->logMsg(sprintf('Password change failed for %s, using (md5ed) password: %s', $auth->get('username'), md5($frm['oldpassword'])), LOG_NOTICE, __FILE__, __LINE__);
     }
 
     if (!$fv->anyErrors()) {
         $auth->setPassword(null, $frm['newpassword']);
-        $app->logMsg(sprintf('Password change successful for %s', $auth->getVal('username')), LOG_INFO, __FILE__, __LINE__);
-        $app->raiseMsg(sprintf(_("Password change successful for %s"), $auth->getVal('username')), MSG_SUCCESS, __FILE__, __LINE__);
+        $app->logMsg(sprintf('Password change successful for %s', $auth->get('username')), LOG_INFO, __FILE__, __LINE__);
+        $app->raiseMsg(sprintf(_("Password change successful for %s"), $auth->get('username')), MSG_SUCCESS, __FILE__, __LINE__);
         $app->dieBoomerangURL('admin_password');
     }