Index: /branches/1.1dev/bin/module_maker/list_template.cli.php
===================================================================
--- /branches/1.1dev/bin/module_maker/list_template.cli.php	(revision 184)
+++ /branches/1.1dev/bin/module_maker/list_template.cli.php	(revision 185)
@@ -104,5 +104,5 @@
 
 <\x3fphp include 'form_error_header.ihtml'; \x3f>
-<form action="<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>" method="post">
+<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="post">
 <\x3fphp printHiddenSession(false); \x3f>
 
Index: /branches/1.1dev/bin/module_maker/module.cli.php
===================================================================
--- /branches/1.1dev/bin/module_maker/module.cli.php	(revision 184)
+++ /branches/1.1dev/bin/module_maker/module.cli.php	(revision 185)
@@ -248,7 +248,7 @@
 $search['admin_form_tag_init'] = '/%ADMIN_FORM_TAG_INIT%/';
 if ($multipart_form_required) {
-    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"12000000\">";
-} else {
-    $replace['admin_form_tag_init'] = "<form method=\"post\" action=\"<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>\">";
+    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"12000000\">";
+} else {
+    $replace['admin_form_tag_init'] = "<form method=\"post\" action=\"<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>\">";
 }
 
Index: /branches/1.1dev/bin/module_maker/skel/adm_list.ihtml
===================================================================
--- /branches/1.1dev/bin/module_maker/skel/adm_list.ihtml	(revision 184)
+++ /branches/1.1dev/bin/module_maker/skel/adm_list.ihtml	(revision 185)
@@ -3,5 +3,5 @@
 
 <div id="commandbox">
-    <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="get">
+    <form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="get">
         <?php printHiddenSession(false); ?>
         <span class="nowrap commandtext"><a href="<?php echo ohref($_SERVER['PHP_SELF'] . '?op=add'); ?>"><?php echo _("Add %ITEM_TITLE%"); ?></a></span>
@@ -18,5 +18,5 @@
 <?php include 'adm_list_info.ihtml'; ?>
 
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
     <?php printHiddenSession(false); ?>
     <table class="list">
Index: /branches/1.1dev/lib/PEdit.inc.php
===================================================================
--- /branches/1.1dev/lib/PEdit.inc.php	(revision 184)
+++ /branches/1.1dev/lib/PEdit.inc.php	(revision 185)
@@ -273,5 +273,5 @@
         }
         ?>
-        <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+        <form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
         <input type="hidden" name="filename" value="<?php echo $this->_filename; ?>" />
         <input type="hidden" name="file_hash" value="<?php echo md5('frog_guts' . $this->_filename); ?>" />
Index: /branches/1.1dev/templates/adm_admin_form.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_admin_form.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_admin_form.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php include 'form_error_header.ihtml'; ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession(); ?>
 <input type="hidden" name="op" value="<?php echo $frm['new_op']; ?>">
Index: /branches/1.1dev/templates/adm_admin_list.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_admin_list.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_admin_list.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 
 <?php include 'form_error_header.ihtml'; ?>
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php $carry_queries = array('search_query', 'filter_admin_priv'); ?>
 <?php printHiddenSession(false); ?>
Index: /branches/1.1dev/templates/adm_log_list.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_log_list.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_log_list.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 
 <?php include 'form_error_header.ihtml'; ?>
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php printHiddenSession(false); ?>
 
Index: /branches/1.1dev/templates/adm_login_form.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_login_form.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_login_form.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession() ?>
 <table border="0" cellspacing="0" cellpadding="4">
Index: /branches/1.1dev/templates/adm_record_lock.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_record_lock.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_record_lock.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession() ?>
 <input type="hidden" name="lock_id" value="<?php echo $lock->getID(); ?>" />
Index: /branches/1.1dev/templates/adm_record_version_list.ihtml
===================================================================
--- /branches/1.1dev/templates/adm_record_version_list.ihtml	(revision 184)
+++ /branches/1.1dev/templates/adm_record_version_list.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession() ?>
 <input type="submit" class="formsubmitbutton" name="op" value="<?php echo _("Cancel"); ?>">
Index: /branches/1.1dev/templates/login_form.ihtml
===================================================================
--- /branches/1.1dev/templates/login_form.ihtml	(revision 184)
+++ /branches/1.1dev/templates/login_form.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession() ?>
 <table border="0" cellspacing="0" cellpadding="4">
Index: /branches/1.1dev/templates/passwd.ihtml
===================================================================
--- /branches/1.1dev/templates/passwd.ihtml	(revision 184)
+++ /branches/1.1dev/templates/passwd.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php include 'form_error_header.ihtml'; ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php printHiddenSession() ?>
 <input type="hidden" name="op" value="update_password">
Index: /tags/2.0.2/bin/module_maker/list_template.cli.php
===================================================================
--- /tags/2.0.2/bin/module_maker/list_template.cli.php	(revision 184)
+++ /tags/2.0.2/bin/module_maker/list_template.cli.php	(revision 185)
@@ -109,5 +109,5 @@
 
 <div id="commandbox">
-<form action="<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>" method="get">
+<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="get">
 <\x3fphp App::printHiddenSession(false); \x3f>
     <span class="nowrap commandtext"><a href="<\x3fphp echo App::oHREF(\$_SERVER['PHP_SELF'] . '?op=add'); \x3f>"><\x3fphp echo _("Add <##>"); \x3f></a></span>
@@ -124,5 +124,5 @@
 <?php include 'list_info.ihtml'; \x3f>
 
-<form action="<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>" method="post">
+<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="post">
 <table class="list">
     <tr>
Index: /tags/2.0.2/bin/module_maker/module.cli.php
===================================================================
--- /tags/2.0.2/bin/module_maker/module.cli.php	(revision 184)
+++ /tags/2.0.2/bin/module_maker/module.cli.php	(revision 185)
@@ -221,5 +221,5 @@
 if ($upload_file_capability) {
     // Form arguments
-    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>\" class=\"sc-form\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"<##>\" />";
+    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>\" class=\"sc-form\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"<##>\" />";
 
     // Include statement.
Index: /tags/2.0.2/bin/module_maker/skel/adm_list.ihtml
===================================================================
--- /tags/2.0.2/bin/module_maker/skel/adm_list.ihtml	(revision 184)
+++ /tags/2.0.2/bin/module_maker/skel/adm_list.ihtml	(revision 185)
@@ -3,5 +3,5 @@
 
 <div id="commandbox">
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="get">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="get">
 <?php App::printHiddenSession(false); ?>
     <span class="nowrap commandtext"><a href="<?php echo App::oHREF($_SERVER['PHP_SELF'] . '?op=add'); ?>"><?php echo _("Add %ITEM_TITLE%"); ?></a></span>
@@ -16,5 +16,5 @@
 </div>
 
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php App::printHiddenSession(); ?>
 <?php include 'list_info.ihtml'; ?>
Index: /tags/2.0.2/lib/PEdit.inc.php
===================================================================
--- /tags/2.0.2/lib/PEdit.inc.php	(revision 184)
+++ /tags/2.0.2/lib/PEdit.inc.php	(revision 185)
@@ -212,6 +212,6 @@
         }
         ?>        
-        <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" id="sc-pedit-form">
-        <input type="hidden" name="filename" value="<?php echo $_SERVER['PHP_SELF']; ?>" />
+        <form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post" id="sc-pedit-form">
+        <input type="hidden" name="filename" value="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" />
         <input type="hidden" name="file_hash" value="<?php echo $this->_fileHash(); ?>" />
         <?php
Index: /tags/2.0.2/lib/RecordLock.inc.php
===================================================================
--- /tags/2.0.2/lib/RecordLock.inc.php	(revision 184)
+++ /tags/2.0.2/lib/RecordLock.inc.php	(revision 185)
@@ -334,5 +334,5 @@
     {
         ?>
-        <form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+        <form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
         <?php App::printHiddenSession() ?>
         <input type="hidden" name="lock_id" value="<?php echo $this->getID(); ?>" />
Index: /tags/2.0.2/services/templates/admin_form.ihtml
===================================================================
--- /tags/2.0.2/services/templates/admin_form.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/admin_form.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php $fv->printErrorMessages(); ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php App::printHiddenSession(); ?>
 <input type="hidden" name="op" value="<?php echo $frm['new_op']; ?>" />
Index: /tags/2.0.2/services/templates/admin_list.ihtml
===================================================================
--- /tags/2.0.2/services/templates/admin_list.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/admin_list.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 
 <?php $fv->printErrorMessages(); ?>
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php App::printHiddenSession(false); ?>
 <div id="commandbox">
Index: /tags/2.0.2/services/templates/lock.ihtml
===================================================================
--- /tags/2.0.2/services/templates/lock.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/lock.ihtml	(revision 185)
@@ -4,5 +4,5 @@
 }
 ?>
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
     <?php App::printHiddenSession() ?>
     <input type="hidden" name="lock_id" value="<?php echo $lock->getID(); ?>" />
Index: /tags/2.0.2/services/templates/log_list.ihtml
===================================================================
--- /tags/2.0.2/services/templates/log_list.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/log_list.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php App::printHiddenSession(false); ?>
 
Index: /tags/2.0.2/services/templates/login_form.ihtml
===================================================================
--- /tags/2.0.2/services/templates/login_form.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/login_form.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php App::printHiddenSession() ?>
 <table>
Index: /tags/2.0.2/services/templates/password.ihtml
===================================================================
--- /tags/2.0.2/services/templates/password.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/password.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php $fv->printErrorMessages(); ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php App::printHiddenSession() ?>
 <input type="hidden" name="op" value="update_password" />
Index: /tags/2.0.2/services/templates/versions_list.ihtml
===================================================================
--- /tags/2.0.2/services/templates/versions_list.ihtml	(revision 184)
+++ /tags/2.0.2/services/templates/versions_list.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php App::printHiddenSession() ?>
 <input type="submit" name="op" value="<?php echo _("Cancel"); ?>" />
Index: /trunk/bin/module_maker/list_template.cli.php
===================================================================
--- /trunk/bin/module_maker/list_template.cli.php	(revision 184)
+++ /trunk/bin/module_maker/list_template.cli.php	(revision 185)
@@ -109,5 +109,5 @@
 
 <div id="commandbox">
-<form action="<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>" method="get">
+<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="get">
 <\x3fphp \$app->printHiddenSession(false); \x3f>
     <span class="sc-nowrap commandtext"><a href="<\x3fphp echo \$app->oHREF(\$_SERVER['PHP_SELF'] . '?op=add'); \x3f>"><\x3fphp echo _("Add __///__"); \x3f></a></span>
@@ -124,5 +124,5 @@
 <?php include 'list_info.ihtml'; \x3f>
 
-<form action="<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>" method="post">
+<form action="<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>" method="post">
 <table class="list">
     <tr>
Index: /trunk/bin/module_maker/module.cli.php
===================================================================
--- /trunk/bin/module_maker/module.cli.php	(revision 184)
+++ /trunk/bin/module_maker/module.cli.php	(revision 185)
@@ -223,5 +223,5 @@
 if ($upload_file_capability) {
     // Form arguments
-    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo \$_SERVER['PHP_SELF']; \x3f>\" class=\"sc-form\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"__///__\" />";
+    $replace['admin_form_tag_init'] = "<form enctype=\"multipart/form-data\" method=\"post\" action=\"<\x3fphp echo oTxt(\$_SERVER['PHP_SELF']); \x3f>\" class=\"sc-form\">\n<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"__///__\" />";
 
     // Include statement.
Index: /trunk/bin/module_maker/skel/adm_list.ihtml
===================================================================
--- /trunk/bin/module_maker/skel/adm_list.ihtml	(revision 184)
+++ /trunk/bin/module_maker/skel/adm_list.ihtml	(revision 185)
@@ -3,5 +3,5 @@
 
 <div id="commandbox">
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="get">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="get">
 <?php $app->printHiddenSession(false); ?>
     <span class="sc-nowrap commandtext"><a href="<?php echo $app->oHREF($_SERVER['PHP_SELF'] . '?op=add'); ?>"><?php echo _("Add %ITEM_TITLE%"); ?></a></span>
@@ -16,5 +16,5 @@
 </div>
 
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php $app->printHiddenSession(); ?>
 <?php include 'list_info.ihtml'; ?>
Index: /trunk/lib/Lock.inc.php
===================================================================
--- /trunk/lib/Lock.inc.php	(revision 184)
+++ /trunk/lib/Lock.inc.php	(revision 185)
@@ -365,5 +365,5 @@
 
         ?>
-        <form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+        <form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
         <?php $app->printHiddenSession() ?>
         <input type="hidden" name="lock_id" value="<?php echo $this->getID(); ?>" />
Index: /trunk/lib/Navigation.inc.php
===================================================================
--- /trunk/lib/Navigation.inc.php	(revision 184)
+++ /trunk/lib/Navigation.inc.php	(revision 185)
@@ -18,6 +18,6 @@
     // Configuration parameters for this object.
     var $_params = array(        
-        'html_title' = true,
-        'body_title' = true,
+        'head_title' => true,
+        'body_title' => true,
         'title' => true,
         'path' => true,
@@ -58,5 +58,5 @@
         $page = array(
             'title' => $title,
-            'url' => is_null($url) ? $_SERVER['PHP_SELF'] : $url;
+            'url' => is_null($url) ? $_SERVER['PHP_SELF'] : $url,
         );
         $this->pages[] = array_merge($page, $vars);
Index: /trunk/lib/PEdit.inc.php
===================================================================
--- /trunk/lib/PEdit.inc.php	(revision 184)
+++ /trunk/lib/PEdit.inc.php	(revision 185)
@@ -228,6 +228,6 @@
         }
         ?>        
-        <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" id="sc-pedit-form">
-        <input type="hidden" name="filename" value="<?php echo $_SERVER['PHP_SELF']; ?>" />
+        <form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post" id="sc-pedit-form">
+        <input type="hidden" name="filename" value="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" />
         <input type="hidden" name="file_hash" value="<?php echo $this->_fileHash(); ?>" />
         <?php
Index: /trunk/services/templates/admin_form.ihtml
===================================================================
--- /trunk/services/templates/admin_form.ihtml	(revision 184)
+++ /trunk/services/templates/admin_form.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php $fv->printErrorMessages(); ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php $app->printHiddenSession(); ?>
 <input type="hidden" name="op" value="<?php echo $frm['new_op']; ?>" />
Index: /trunk/services/templates/admin_list.ihtml
===================================================================
--- /trunk/services/templates/admin_list.ihtml	(revision 184)
+++ /trunk/services/templates/admin_list.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 
 <?php $fv->printErrorMessages(); ?>
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php $app->printHiddenSession(false); ?>
 <div id="commandbox">
Index: /trunk/services/templates/lock.ihtml
===================================================================
--- /trunk/services/templates/lock.ihtml	(revision 184)
+++ /trunk/services/templates/lock.ihtml	(revision 185)
@@ -4,5 +4,5 @@
 }
 ?>
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
     <?php $app->printHiddenSession() ?>
     <input type="hidden" name="lock_id" value="<?php echo $lock->getID(); ?>" />
Index: /trunk/services/templates/log_list.ihtml
===================================================================
--- /trunk/services/templates/log_list.ihtml	(revision 184)
+++ /trunk/services/templates/log_list.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
+<form action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>" method="post">
 <?php $app->printHiddenSession(false); ?>
 
Index: /trunk/services/templates/login_form.ihtml
===================================================================
--- /trunk/services/templates/login_form.ihtml	(revision 184)
+++ /trunk/services/templates/login_form.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php $app->printHiddenSession() ?>
 <table>
Index: /trunk/services/templates/password.ihtml
===================================================================
--- /trunk/services/templates/password.ihtml	(revision 184)
+++ /trunk/services/templates/password.ihtml	(revision 185)
@@ -1,5 +1,5 @@
 <?php $fv->printErrorMessages(); ?>
 
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php $app->printHiddenSession() ?>
 <input type="hidden" name="op" value="update_password" />
Index: /trunk/services/templates/versions_list.ihtml
===================================================================
--- /trunk/services/templates/versions_list.ihtml	(revision 184)
+++ /trunk/services/templates/versions_list.ihtml	(revision 185)
@@ -1,3 +1,3 @@
-<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
+<form method="post" action="<?php echo oTxt($_SERVER['PHP_SELF']); ?>">
 <?php $app->printHiddenSession() ?>
 <input type="submit" name="op" value="<?php echo _("Cancel"); ?>" />